// bump.frag
#version 120
uniform vec4 eyePosition;
uniform vec4 lightPosition;

varying vec3 normal;
varying vec3 position;

// ڐxNǧvZ
vec3 calculateTangent()
{
    vec3 tant;
    // xNg
    vec3 up = normalize(gl_NormalMatrix*vec3(0,1,0));
    // @xNg
    vec3 fnormal = normalize(normal);
    if (abs(dot(up, fnormal)) > 0.99999)
    {
        tant = up;
    }
    else
    {
        // OςŉExNgvZ
        vec3 right = cross(up, fnormal);
        // ExNgڐxNgvZ
        tant = normalize(cross(fnormal, normalize(right)));
    }

    return tant;
}

void main (void)
{
#if 0
    // F̐ݒ
	vec4 diffuse = vec4(0.7, 0.7, 0.9, 1.0);
	vec4 ambient = vec4(0.1, 0.1, 0.2, 1.0);
	vec4 specularColor = vec4(0.7, 0.7, 0.9, 1.0);
	float shininess = 20.0;
#elif 0
    // F̐ݒ(^)
	// http://mailsrv.nara-edu.ac.jp/~asait/open_gl/sample4/sample4.htm
	vec4 ambient = vec4(0.25, 0.20725, 0.20725, 1.0);
	vec4 diffuse = vec4(1.0, 0.829, 0.829, 1.0);
	vec4 specularColor = vec4(0.296648, 0.296648, 0.296648, 1.0);
	float shininess = 10.24;
#elif 1
    // F̐ݒ()
	// http://mailsrv.nara-edu.ac.jp/~asait/open_gl/sample4/sample4.htm
	vec4 ambient = vec4(0.2125, 0.1275, 0.054, 1.0);
	vec4 diffuse = vec4(0.714, 0.4284, 0.18144, 1.0);
	vec4 specularColor = vec4(0.393548, 0.271906, 0.166721, 1.0);
	float shininess = 25.6;
#else
    // F̐ݒ(N[)
	// http://mailsrv.nara-edu.ac.jp/~asait/open_gl/sample4/sample4.htm
	vec4 ambient = vec4(0.25, 0.25, 0.25, 1.0);
	vec4 diffuse = vec4(0.4, 0.4, 0.4, 1.0);
	vec4 specularColor = vec4(0.774597, 0.774597, 0.774597, 1.0);
	float shininess = 76.8;
#endif

    // ւ̃xNǧvZ
	vec4 lightPos = gl_LightSource[0].position;
	if (lightPos.w > 0)
	{
	    lightPos /= lightPos.w;
	}
    vec3 lightVec = normalize(lightPos.xyz);
    float distance = length(lightPos.xyz - position);

    // _ւ̃xNǧvZ
    vec3 viewVec = normalize(-position);

    // KɌvZ
    float attenuation = 1.0 / (1.0+0.05*distance+0.01*distance*distance);

    // ڐxNgƂ̓ςvZ
    vec3 ftangent = normalize(calculateTangent());
    float dotLT = dot(lightVec, ftangent);
    float dotVT = dot( viewVec, ftangent);
    // LENƁVEŘvZiPPTQƁj
    float dotLN = sqrt(1.0-dotLT*dotLT);
    float dotVR = dotLN*sqrt(1.0-dotVT*dotVT)-dotLT*dotVT;
    float specular = pow(max(dotVR, 0.0), shininess);

    // F̌vZ
    vec4 Iambient = ambient; 
    vec4 Idiffuse = diffuse * max(dotLN,0.0) * attenuation;
    vec4 Ispecular = specularColor * specular * attenuation;
    // diffusespecular͒
    gl_FragColor = Iambient + 4.0*((Idiffuse + Ispecular));
}